/*
 * Copyright 2003 - 2011 The eFaps Team
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Revision:        $Rev: 7685 $
 * Last Changed:    $Date: 2012-06-18 10:34:35 -0500 (Mon, 18 Jun 2012) $
 * Last Changed By: $Author: jan@moxter.net $
 */


package org.efaps.maven.plugin.install.digester;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.digester3.annotations.rules.BeanPropertySetter;
import org.apache.commons.digester3.annotations.rules.ObjectCreate;
import org.apache.commons.digester3.annotations.rules.SetNext;


/**
 * TODO comment!
 *
 * @author The eFaps Team
 * @version $Id: StatusCI.java 7685 2012-06-18 15:34:35Z jan@moxter.net $
 */
@ObjectCreate(pattern = "datamodel-statusgroup")
public class StatusCI
    implements ITypeCI
{

    private final List<StatusCIDefinition> definitions = new ArrayList<StatusCIDefinition>();

    @BeanPropertySetter(pattern = "datamodel-statusgroup/uuid")
    private String uuid;

    /**
     * Getter method for the instance variable {@link #uuid}.
     *
     * @return value of instance variable {@link #uuid}
     */
    public String getUuid()
    {
        return this.uuid;
    }

    /**
     * Setter method for instance variable {@link #uuid}.
     *
     * @param _uuid value for instance variable {@link #uuid}
     */

    public void setUuid(final String _uuid)
    {
        this.uuid = _uuid;
    }

    /**
     * Getter method for the instance variable {@link #definitions}.
     *
     * @return value of instance variable {@link #definitions}
     */
    public List<StatusCIDefinition> getDefinitions()
    {
        return this.definitions;
    }

    @SetNext
    public void addDefinition(final StatusCIDefinition definition)
    {
        this.definitions.add(definition);
    }
}

